<?php
require_once(realpath(dirname(__FILE__)). '/LC_Page_Mdl_Dchk.php');

class LC_Page_Mdl_Dchk_Credit extends LC_Page_Mdl_Dchk {

    /**
     * @see LC_Page_Mdl_Dchk::action()
     */
    function action(){

        $objSiteSess = new SC_SiteSession_Ex();
        $objPurchase = new SC_Helper_Purchase_Ex();
        $objCustomer = new SC_Customer_Ex();
        $objParam    = new SC_FormParam_Ex();
        
        $order_id = $_SESSION['order_id'];
        
        $arrOrderData = $objPurchase->getOrder($order_id);
        $this->idpayment = false;
        $this->shop_id = $this->credit_shop_id;

        if ($arrOrderData['payment_total'] == 0) {
            $this->skipSettlement($order_id);
        }

        if ($arrOrderData['del_flg'] == 1) {
            $this->arrEr = array("message"=>"不正なページ遷移が行われました。");
            LC_Helper_Mdl_Dchk::log("不正なページ遷移が行われました。[SID:".$order_id."]");
            $this->viewError();
        }


        //ID決済
        if (($_SESSION['use_regcard'] == 1) 
            and $arrOrderData["customer_id"] > 0 
            and $objCustomer->getValue("regist_card") == 1) {
            LC_Helper_Mdl_Dchk::log("クレジットID決済を行います:".$_SESSION['use_regcard']);
            // ID決済の場合
            $this->idpayment = true;

            // POSTデータを送信し、応答情報を取得する
            // データ作成
            $arrSendData = $this->createSendData($order_id);
            unset($arrSendData["OKURL"],$arrSendData["RT"],$arrSendData["STORE"]);
            $response = LC_Helper_Mdl_Dchk::POST(DCHK_CREDIT_URL, $arrSendData);

            // なにも返ってこなれば、エラー
            if ($response == "") {
                // エラー画面を表示する。
                $_SESSION['site']['now_page'] ="";
                $this->rollbackOrder($order_id);
                LC_Helper_Mdl_Dchk::log("URL:$order_url 応答がありません。");
                $this->arrEr = array("応答がありません");
                $this->viewError();
            }
            $arrResponse = explode("\r\n", mb_convert_encoding($response,"UTF-8", "SJIS"));
            if ($arrResponse[0] != "OK") {
                $this->rollbackOrder($order_id);
                LC_Helper_Mdl_Dchk::log(mb_convert_encoding(print_r($response,1),"UTF-8","SJIS"));
                if (mbereg(".*EXPERR.*", $response)) {
                    $this->arrEr = array("message"=>"有効期限切れエラーです");
                    LC_Helper_Mdl_Dchk::log("有効期限切れエラーです");
                } else if (mbereg(".*PRERROR.*", $response))  {
                    $this->arrEr = array("message"=>"パラメータエラーです。[メッセージ：".$arrResponse[2]."]");
                    LC_Helper_Mdl_Dchk::log("パラメータエラーです。[メッセージ：".mb_convert_encoding(print_r($arrResponse,1),"UTF-8","SJIS")."]");
                } else {
                    $this->arrEr = array("message"=>"システムエラーです。[メッセージ：".$arrResponse[2]."]");
                    LC_Helper_Mdl_Dchk::log("システムエラーです。[メッセージ：".mb_convert_encoding(print_r($arrResponse,1),"UTF-8","SJIS")."]");
                }
                $this->viewError();
            } else {
                LC_Helper_Mdl_Dchk::log('ID決済完了。完了ページに移動します');
                $objSiteSess->setRegistFlag();
                $this->completeSettlement($order_id,$arrResponse);
                $objPurchase->sendOrderMail($order_id);
                
                SC_Response_Ex::sendRedirect(SHOPPING_COMPLETE_URLPATH);
                SC_Response_Ex::actionExit();
            }
        //通常決済
        } else {
            $objSiteSess = new SC_SiteSession_Ex();
            // EC-CUBE確認画面からの遷移
            $order_id = $_SESSION['order_id'];
            LC_Helper_Mdl_Dchk::log('受注ID:'.$order_id);
    
            if($_GET["return"] == 1){
                $this->rollbackUsePoint($order_id);
                $this->rollbackOrder($order_id);
                $objSiteSess->setRegistFlag();
                SC_Response_Ex::sendRedirect(SHOPPING_PAYMENT_URLPATH);
                SC_Response_Ex::actionExit();
            }
    
    
            if ($_SERVER['REQUEST_METHOD'] === 'GET') {
                // 戻りパラメータがある時
                if ($this->checkRetParam($_GET)) {
                    LC_Helper_Mdl_Dchk::log('DCHKからの戻り値:'.print_r($_GET, true));
                    // 正常完了処理
                    $objSiteSess->setRegistFlag();
                    
                    $this->completeSettlement($order_id);
                    //ID決済用フラグ設定
                    if($arrOrderData["customer_id"] > 0){
                        $this->setRegistCard($arrOrderData["customer_id"]);
                    }
                    $objPurchase->sendOrderMail($order_id);

                    LC_Helper_Mdl_Dchk::log('完了ページに移動します');
                    SC_Response_Ex::sendRedirect(SHOPPING_COMPLETE_URLPATH);
                    SC_Response_Ex::actionExit();
    
                } else if ($_GET['transactionid']) {
                    LC_Helper_Mdl_Dchk::log("オーダーURL：".$this->getOrderUrl()."へリダイレクトします");
                    // データ作成
                    $arrSendData = $this->createSendData($order_id);
                    LC_Helper_Mdl_Dchk::log("パラメータ：".mb_convert_encoding(print_r($arrSendData, 1),"UTF-8","SJIS"));
                    // 送信先URLへリダイレクト
                    LC_Helper_Mdl_Dchk::sendRedirect($this->getOrderUrl(),$arrSendData);
                } else {
                    LC_Helper_Mdl_Dchk::log('パラメータが不正です:'.print_r($_GET,true));
                    $this->rollbackOrder($order_id);
                    SC_Response_Ex::sendRedirect(SHOPPING_CONFIRM_URLPATH);
                    SC_Response_Ex::actionExit();
                }
            } else {
                // POSTの場合
                LC_Helper_Mdl_Dchk::log('不正な'.$_SERVER['REQUEST_METHOD'].'リクエストを受信しました');
                $this->rollbackOrder($order_id);
                SC_Response_Ex::sendRedirect(SHOPPING_CONFIRM_URLPATH);
                SC_Response_Ex::actionExit();
            }
        }
    }

    function viewError() {
        SC_Utils_Ex::sfDispSiteError(FREE_ERROR_MSG, '', true , $this->arrEr['message']);
    }

    /**
     * 発注データを取得します.
     */
    function getOrderData($order_id) {

        if ($_SESSION['use_regcard'] == 1) {
            $arrSendData = array(
                'PASS' => $this->credit_shop_pass
            );
        } else {
            return parent::getOrderData($order_id);
        }
        return $arrSendData;
    }

    /**
     * 決済方法を取得します。
     */
    function getStore() {
      return "51";
    }

    /**
     * 完了URLを取得します。
     */
    function getOkUrl() {
        $url = HTTPS_URL.'shopping/load_payment_module.php?'.TRANSACTION_ID_NAME."=".$this->transactionid;
        if(SC_Display::detectDevice() == DEVICE_TYPE_MOBILE){
            $url .= "&". session_name() ."=". session_id() ;
        }
        return $url;
    }

    /**
     * 戻りURLを取得します。
     */
    function getReturnUrl() {
        $url = HTTPS_URL.'shopping/load_payment_module.php?return=1&'.TRANSACTION_ID_NAME."=".$this->transactionid;
        if(SC_Display::detectDevice() == DEVICE_TYPE_MOBILE){
            $url .= "&". session_name() ."=". session_id() ;
        }
        return $url;
    }

        /**
     * 決済ごとの独自情報を取得します。
     */
    function getExtData() {
        if($_SESSION['customer']['customer_id'] > 0){
            return array(
                'KAKUTEI' => 0, // 与信
                'IP_USER_ID' => $_SESSION['customer']['customer_id'] // ユーザID
            );
        }else{
            return array(
                'KAKUTEI' => 0 // 与信
            );
        }
    }

    /**
     * 送信先URLを取得します。
     * @see LC_Page_Mdl_Dchk::getOrderUrl()
     */
    function getOrderUrl() {
        return DCHK_CREDIT_LINK;
    }
    
    /**
     * 戻りURLを取得します。
     */
    function setRegistCard($customer_id){
        LC_Helper_Mdl_Dchk::log("ID決済用フラグ設定 customer_id: ".$customer_id);
        $objQuery =& SC_Query_Ex::getSingletonInstance();
        $sqlval = array("regist_card" => 1);
        $objQuery->update("dtb_customer",$sqlval,"customer_id = ?",array($customer_id));
    }
    
    //通常完了時のステータス設定
    function completeSettlement($order_id) {
        $sqlval = array(
            'payment_date' => 'now()', // 入金日時
            'update_date' => 'now()',
            'dchk_status' =>DCHK_STATUS_COMPLETE
        );
        $objPurchase = new SC_Helper_Purchase_Ex();
        $objPurchase->sfUpdateOrderStatus($order_id, ORDER_PAY_WAIT, null, null, $sqlval);
        LC_Helper_Mdl_Dchk::log('update order status: ORDER_PAY_WAIT');
        if( $this->credit_kakutei == "true" ){
            $commit = array(
                "IP"=>$this->shop_id,
                "SID"=>$order_id
            );
            $response = LC_Helper_Mdl_Dchk::POST(DCHK_CREDIT_COMPLETE_URL, $commit);
            $arrResponse = explode("\r\n", mb_convert_encoding($response,"UTF-8", "SJIS"));
            if( strpos($arrResponse[0],"C-CHECK:OK") !== false ){
                LC_Helper_Mdl_Dchk::log('update order status: ORDER_NEW');
                $objPurchase = new SC_Helper_Purchase_Ex();
                $objPurchase->sfUpdateOrderStatus($order_id, ORDER_NEW, null, null, $sqlval);
            }else{
                LC_Helper_Mdl_Dchk::log('クレジットカード決済の確定に失敗しました。');
            }
        }
        unset($_SESSION["order_id"],$_SESSION["use_regcard"]);
    }

    //決済金額が0円の時は決済をスキップ
    function skipSettlement($order_id) {
        LC_Helper_Mdl_Dchk::log('決済金額が0円のため決済処理をスキップします。');
        $sqlval = array(
            'payment_date' => 'now()', // 入金日時
            'update_date' => 'now()',
            'dchk_status' => DCHK_STATUS_WAIT
        );
        $objPurchase = new SC_Helper_Purchase_Ex();
        $objPurchase->sfUpdateOrderStatus($order_id, ORDER_NEW, null, null, $sqlval);

        $objSiteSess = new SC_SiteSession_Ex();
        $objSiteSess->setRegistFlag();
        $objPurchase = new SC_Helper_Purchase_Ex();
        $objPurchase->sendOrderMail($order_id);
        LC_Helper_Mdl_Dchk::log('完了ページに移動します');
        SC_Response_Ex::sendRedirect(SHOPPING_COMPLETE_URLPATH);
        SC_Response_Ex::actionExit();
   }

    function rollbackUsePoint($order_id){
        $objPurchase = new SC_Helper_Purchase_Ex();
        $arrOrder = $objPurchase->getOrder($order_id);

        if($arrOrder['use_point'] && $arrOrder['del_flg'] == 0){
            $objQuery =& SC_Query_Ex::getSingletonInstance();
            $sqlval = array();
            $where = '';
            $arrVal = array();
            $arrRawSql = array();
            $arrRawSqlVal = array();

            $sqlval['update_date'] = 'Now()';
            $arrRawSql['point'] = 'point + ?';
            $arrRawSqlVal[] = $arrOrder['use_point'];
            $where .= 'customer_id = ?';
            $arrVal[] = $arrOrder['customer_id'];

            $objQuery->update('dtb_customer', $sqlval, $where, $arrVal, $arrRawSql, $arrRawSqlVal);
        }
    }

}
